﻿//セル（全セルまたは一部のセル）を選択した状態で実行してください。

var myTable = app.activeDocument.selection[0];  //選択されたセル（セル群）
if(myTable == null){   //選択されていない場合
alert("セルを選択してから実行してください")
exit();
}
var myType=myTable.toString();
if(myType=="[object Cell]"){
myTable=myTable.parent;
}
else if(myType=="[object Table]"){
}
else{
alert("セルを選択してから実行してください");
exit();
}

//セルをマージ
var r = myTable.rows.length;    //行数
var c = myTable.columns.length; //列数
var h = myTable.headerRowCount; //ヘッダの行数
var f = myTable.footerRowCount; //フッタの行数

//ダイアログ（Window）の設定
var dlg = new Window('dialog', "処理範囲を選択", undefined, {borderless: false});	//borderlessは上の帯の有無らしい
dlg.panel = dlg.add('panel');
dlg.panel.alignChildren = 'left';
var stAry = [ "表組み全体" , "ヘッダとフッタを除く" ];
var conf_obj = {};

//ドロップダウンリスト11
var ddl11 = dlg.panel.add('dropdownlist',  [0,0,240,23], stAry);
ddl11.title = '';
ddl11.selection = conf_obj['place'] === undefined ? 0 : conf_obj['place'];	//何番目を初期表示とするか（らしい）

//buttonエリア
dlg.group = dlg.add('group');
var ok_btn = dlg.group.add('button', undefined,"OK", {name:'ok'});
var can_btn = dlg.group.add('button',undefined,"Cancel", {name:'cancel'});

ok_btn.onClick = function () {
dlg.close();
exit();
}
dlg.show();

if(ddl11.selection == 1){
alert("ヘッダとフッタを除く");
r=r-f;
}else{
alert("表組み全体");
h=0;     //全体の場合はhを0とする
} 

try{ 
//空のセルに∈∋を入力
for ( j = c-1 ;  j >= 0;  j--  ) {
for ( i = r-1 ;  i >= h;  i--  ) {
if(myTable.rows[i].cells[j].contents==""){
myTable.rows[i].cells[j].contents="∈∋";
}
}
}

//結合
for ( j = c-1 ;  j >= 0;  j--  ) {
for ( i = r-1 ;  i >= h;  i--  ) {
if(myTable.rows[i].cells[j].contents[0]=="⊂"){
myTable.rows[i].cells[j].merge(myTable.rows[i].cells[j-1]);    
}else if(myTable.rows[i].cells[j].contents[0]=="∩"){
myTable.rows[i].cells[j].merge(myTable.rows[i-1].cells[j]);   
}
}    
}
}catch(e){
alert("結合済みのセルが存在しないか確認してください");
exit();
}

//置換設定
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか

//≪≫を改行に置換
app.findGrepPreferences.findWhat = "≪≫";
app.changeGrepPreferences.changeTo = "\r";
myTable.changeGrep(); 

//不要な⊂と∩（改行）を削除
app.findGrepPreferences.findWhat = "\r[⊂∩]";
app.changeGrepPreferences.changeTo = "";
myTable.changeGrep(); 

//∈∋を削除
app.findGrepPreferences.findWhat = "∈∋";
app.changeGrepPreferences.changeTo = "";
myTable.changeGrep(); 

app.findGrepPreferences.findWhat = "";