var myTable = app.activeDocument.selection[0];  //選択されたセル（セル群）
if(myTable == null){   //選択されていない場合
	alert("セルを選択してから実行してください")
	exit();
	}
var myType=myTable.toString();
if(myType=="[object Cell]"){
	myTable=myTable.parent;
	}
else if(myType=="[object Table]"){
	}
else{
	alert("セルを選択してから実行してください");
	exit();
	}

var myTexrFrame = myTable.parent ;  //myTableが存在するテキストフレーム
var myStory = myTexrFrame.parentStory ; //myTableが含まれるストーリー
var myTableIndex = myTable.index ;   //ストーリーで何番目のテーブルか（0から）
var myInsertionPoint = myTable.storyOffset.index ;  //挿入点のindex

myTable.select();  //テーブルを選択する
app.copy(); //テーブルをコピー
app.select(myStory.insertionPoints[myInsertionPoint+1]);    //次のinsertionPointsを選択
app.paste();    //テーブルをペースト

var r = myTable.rows.length;    //行数
var c = myTable.columns.length; //列数
var tableA = myStory.tables[myTableIndex] ; //前のテーブル（元からあるもの）
var tableB = myStory.tables[myTableIndex+1] ;   //後のテーブル（複製したもの）

//行数列数をひっくり返す
if (r<c){
    for(m=r ; m < c ; m++){
		tableB.rows.add();
		tableB.columns[0].remove();
    }
}
if (c<r){
    for(n=c ; n < r ; n++){
		tableB.columns.add();
		tableB.rows[0].remove();
    }
}

//セルを順にコピペ
for( p=0 ; p<r ; p++ ){
    for( q=0 ; q<c ; q++ ){
        tableA.rows[p].cells[q].select();
        app.copy();
        tableB.columns[p].cells[q].select();
        app.paste();
    }
}
tableA.remove();